; routine to cycle through the files
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include aid_mac
        include struct_h
        include dev8_err
        include dev8_ext_thg
*
; routine to cycle through the files
; filename is max 32 chars long and that amount of space has to be available in the return string !!
; if seed 0 after return, then string will not be set
; parameters:
p.id    equ     $4      ; ptr to seed (ulong, will be updated, zero to start)
p.ret   equ     $c      ; return filename (string or substring (C-string))
; errors
; itnf  seed invalid
cod_CYCL xsub
        regsave d1/a1/a4/a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),a1     ; place with fileid
        move.l  (a1),d0         ; fileid to test
        bne.s   cont
        xjsr    frstfid         ; get first fileid
        bra.s   ret

cont    ; get the next fileid if it is valid
        xjsr    testfid         ; test fileid
        bne.s   codend          ; oops, invalid seed
        move.l  (a1),a4
        move.l  f_next(a4),d0   ; take next fileid

ret     ; now return what they wanted to know
        move.l  d0,(a1)         ; fill in fileid
        beq.s   codend          ; no file -> end
        move.l  d0,a4           ; fileid
        lea     f_name(a4),a4   ; start of filename
        move.w  p.ret-4(a5),d1
        move.w  (a4)+,d0        ; filename length
        move.l  p.ret(a5),a1    ; place to fill in return value
        btst    #thp..sst,d1    ; return substring ??
        bne.s   sstr
        move.w  d0,(a1)+        ; fill in len
sstr    tst.w   d0
        beq.s   endstr
        subq.w  #1,d0           ; adjust to dbf
lp      move.b  (a4)+,(a1)+     ; copy 'another' char
        dbf     d0,lp
endstr  btst    #thp..sst,d1    ; return substring ??
        beq.s   done
        clr.b   (a1)+           ; end of string marker
done    moveq   #0,d0           ; no error
codend
        subend
;
        end
