; routine to get the fieldtype when fieldid given
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include aid_mac
        include struct_h
        include dev8_err
*
; get fieldtype when fieldid given
; parameters
p.id    equ     $4      ; bufferid or indexid (long word, optional)
p.fld   equ     $8      ; id of field (call uword, opt, nnul)
p.ret   equ     $10     ; return field id (uword)
; errors
; itnf  buffer id invalid
; ipar  fieldid doesn't exist
cod_FLDT xsub
        regsave d1/a1-a5
        move.l  a1,a5           ; put it in a safe place

        tst.w   p.id-4(a5)      ; is the parameter given
        bne.s   a_nodef         ; yep -> don't use default
        xjsr    getbuff         ; default buffer for this job in d0
        move.l  d0,a4           ; bufferid in a4
        xjsr    testbid         ; now, is it a valid buffer ?
        bne.s   codend          ; no -> don't do anything
        bra.s   a_ret           ; return asked value
a_nodef move.l  p.id(a5),a4     ; get the given id
        move.l  a4,d0
        xjsr    testbid         ; is it a buffer id
        beq.s   a_ret           ; return asked value
        move.l  p.id(a5),a3     ; oops, can it be an index id
        move.l  a3,d0
        xjsr    testiid         ; check it out
        bne.s   codend          ; who the hell did the parameter parsing ?
        move.l  i_buffer(a3),a4 ; buffer for this index
a_ret
        move.w  p.fld+2(a5),d1  ; field id
        bpl.s   notdef          ; no, we don't need the default
        moveq   #0,d1
        move.b  b_dfield(a4),d1 ; default field
notdef
        move.l  b_file(a4),a4   ; we only need fileid

        ; now find out the field type
        moveq   #err.ipar,d0    ; assume fieldid doesn't exist
        mulu    #18,d1          ; start of field
        add.w   #f_fields,d1    ; offset in filedata
        lea     0(a4,d1.w),a4   ; start of field
        tst.w   (a4)            ; does this field exist ?
        beq.s   codend          ; no it doesn't

        ; now return what they wanted to know
        moveq   #0,d0           ; make it a word
        move.b  (a4),d0         ; take field type
        move.l  p.ret(a5),a1    ; place to fill in return value
        move.w  d0,(a1)         ; fill in return value
        moveq   #0,d0           ; no error
codend
        subend
;
        end
