; get record id
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include aid_mac
        include struct_h
        include dev8_err
*
; get record id
; return -1 if recordid can't be given !!
; parameters
p.id    equ     $4      ; buffer id (long word, optional)
p.ret   equ     $c      ; return record id (ulong)
; errors
; itnf  buffer id invalid
; iexp  oops, no recordid just yet (return -1)
cod_IDRE xsub
        regsave a1/a4/a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   idbuff          ; yes -> ..
        xjsr    getbuff         ; get default buffer
idbuff  move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   idend           ; if not -> error

        move.l  p.ret(a5),a1    ; place to put return parameter
        move.l  #-1,(a1)
        moveq   #err.iexp,d0    ; assume we can't give the recordid just yet
        tst.b   b_new(a4)       ; check it out
        bne.s   idend           ; you see ...

        move.l  b_id(a4),(a1)   ; fill in return value
        moveq   #0,d0           ; and no error
idend
        subend
;
        end
