; get/set viewstatus
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include aid_mac
        include struct_h
*
; return the viewstatus (0 read/write, <>0 read-only)
; parameters
p.id    equ     $4      ; buffer id (long word, optional)
p.ret   equ     $c      ; return status (ret+uword, has to be there)
; errors
; itnf  buffer id invalid
cod_GVST xsub
        regsave d1/a1/a3/a4/a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   codend          ; if not -> error

        move.l  p.ret(a5),a1    ; place for return
        moveq   #0,d1
        move.b  b_view(a4),d1   ; return value
        move.w  d1,(a1)         ; fill in
codend
        subend
*
; set the viewstatus (0 read/write, 1 read-only)
; also clears the record in the buffer
; parameters
;p.id    equ     $4      ; buffer id (long word, optional)
p.val   equ     $8      ; new view status
; errors
; itnf  buffer id invalid
cod_SVST xsub
        regsave d1/a1/a3/a4/a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff2          ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff2  move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   codend2         ; if not -> error

        xjsr    cod_NEWR
        move.b  p.val+3(a5),b_view(a4)  ; set new value
        moveq   #0,d0
codend2
        subend
;
        end
