* file voor het initialiseren van de DATAdesign engine thing
* (c) Nov 1990/1991 by Joachim Van der Auwera ;for PROGS
* aangepast voor v3.00, juli 1992
*
        section init
        include win1_inc_qdos_sms
        include win1_inc_keys_qlv
        include win1_inc_keys_thg
        include win1_inc_keys_err
*
        xref    thg_fthg
        xdef    dde_name
*
        bra.s   th_init
*
dde_name
        dc.w    17,'DATAdesign.engine '
        dc.b    ' v'
dde_vers
        dc.b   '3.11'
linkmess
        dc.w    endmess-*-2
        dc.b    'DATAdesign engine v3.11 installed',10
        dc.b    '(c) 1991/92/93/94 PROGS',10
endmess

* v1.00  oorspronkelijke versie (maart 1991)
* v1.01  PRIN nu juiste item in lijst en juiste aantal items
*              probleem i.v.m. veranderen 3de letter bij uitprinten lijst opgelost
*        SETS werkt (terug) zoals het moet (geen error meer) (begin april 1991)
* v1.02  PRIN filtered en marked records kunnen nu ook geselecteerd worden
*             fout cfr selecteren van records in lijst opgelost
*        NEWF de formstring wordt bijgehouden bij het wissen van de file (cf LOAD)
*        SAVE probleem i.v.m. selectie in lijst opgelost
*             de filename wordt nu alleen aangepast als de volledige file gesaved wordt (eind juni 1991)
* v1.03  PRIN form-string behandelt veldnrs>10 nu zoals het moet ( 13/07/1991 )
* v1.04  SETS a line can now be replaced by a shorter one ( 31/08/1991 )
* v1.05  files are now in common memory, a special '_ddf list' job and thing is created with the files (start 11/9/91)
*        MERG werkt
*        nieuwe extenties SPLL, CLRM, APLN, PRVF, NXTF, DLLN, CLRF
*        FIND kan nu ook zoeken vanaf lege record
*        PRIN aanvaardt nu ook delete a record zonder lijst, maar alleen met defn eerste (af 23/10)
*        and en or in FILT
* v1.06  SRT0 added, sort routine with 10 levels
*        SORT and SRT0 can now mark out equal records (rond 30/11)
* v1.07  loading and saving can now use DATA_USE device
*        buffer increased to 8k
*        PRIN form string, field numbers are now normal (1 is field 1 etc)
*        new file format for file configuration for main program ( rond 12/2/92 )
*        _ddp automatisch added als nodig
*        als load niet gaat, proberen _ddf aan te hangen
* v3.00  Complete rewrite, everything changed
*        files can now also be disk based, lot's of added commands
*        sort/filt/find now index based, form string thrown out (no built in print)
*        (vanaf 1/7/92 tot 20/01/93)
* v3.01  NEWR now also works for read-only files
*        NEXT/PREV/LAST/FRST had problems with index without sort
*        FILT had a problem with AND levels
*        FILT now also a 'As string' option added (02/03/93)
*        FORW/BCKW added
* v3.02  UNUS had a bug, it left the current record locked
* v3.03  Minerva incompatibility solved ( WRONG !! )
*        high word of d1 gets smashed in io.fmul and io.smul
*        problems with SAVF solved (did close channel, but didn't clear chid)
* v3.04  FILT on numerical fields didn't work
*        SORT didn't work properly on doubles
*        FILT didn't compare doubles properly
*        IFND didn't compare doubles properly
*        there was a mistake when converting ql float to ieee (i.e. -.5 wrong)
*        UNUS also closed channel when not there (caused Minerva problems)
*               -> Minerva problems properly solved
* v3.05  FILT comparing shorts was not completely correct
*        SORT did not fill the filter field types properly
*        FLDT now also accepts an indexid instead of bufferid
*               -> for filter in basic, caused bad parameter
* v3.06  basic i/f FINDinteger now also accepts integer as search value
*        IUPD, ILOA forgot to test for out of memory sometimes
*        IMPL on disk-based file should now always work, there was a problem
*             when checking whether there is enough free space on the disk
*        IMPL should no longer have problems when writing to read-only disks
*        IFND now returns the closest match which is smaller when not found
*        IUPD small change in index linkin routine (some no-op's added,
*             because there sometimes occured an illegal instruction, search me)
*       (08/07/1993)
* v3.07 general improvement, the DATAdesign engine no longer enters supervisor,
*       improvement made by introducing a 'DATAdesign mutex' thing to assure
*       mutual exclusion
* v3.08 mistake in DATAdesign mutex thing solved. There was no pointer to the
*       actual thing. This made Qpac2 crash on TT.
* v3.09 SORT could sometimes crash on TT (and cause problems on the rest).
*            There was a mistake in the balance after a double rotation (p1).
*       FIND String/Integer/Double reverse order caused infinite loop (05/01/1994)
*       DEFI was faulty, only allowed resetting
*       FILT string, position<>0 didn't work (10/01/1994)
* v3.10 FRST/LAST/NEXT/PREV/FORW/BCKW failed to return error on faulty buffer
*            and indexid (31.03.1994)
* v3.11 DATAdesign files job now always owned by system (21.05.1994)
*       GREC failed to increase the size of the buffer when trying to access a
*       larger record from a disk based file (23.05.1994)

joblen  equ     26
jbhdr
here    bra     here
        nop
        nop
        dc.w    $4afb
jbname  dc.w    16
        dc.w    'DATAdesign files'

; routine om DATAdesign te initialiseren
th_init
        jsr     thg_fthg(pc)    ;find THING-thing
        move.l  8(a3),a4        ;ptr to th_entry
        lea     dde_name(pc),a0 ;name of thing to remove
        moveq   #sms.rthg,d0    ;Remove Thing from list
        jsr     (a4)
        cmpi.w  #err.fdiu,d0    ; if thing in use
        beq     ok              ; -> don't overwrite

        moveq   #0,d1           ; owner job, system
        moveq   #0,d3           ; dataspace area
        moveq   #joblen,d2      ; length of code (joblen)
        moveq   #sms.crjb,d0    ; create job
        suba.l  a1,a1           ; clear a0, no start address yet
        trap    #do.sms2
        tst.l   d0
        bne     kill            ; error -> ..
        move.l  d1,d7           ; job id in d7 zetten
        lea     jbhdr(pc),a1    ; job itself
        moveq   #joblen-1,d0    ; joblen-1
lp      move.b  (a1)+,(a0)+
        dbf     d0,lp

        move.l  #60+$1a+520,d1  ; thing linkage, eerste extension, data gebied
        moveq   #sms.achp,d0    ; reserve memory for thing linkage and INFO extension
        move.l  d7,d2           ; job id of 'DATAdesign files' job
        trap    #1
        tst.l   d0
        bne.s   kill

        move.w  #151,d0
        move.l  a0,a2
lnk_clr clr.l   (a2)+
        dbf     d0,lnk_clr      ; clear the linkage block

        moveq   #4,d0           ; nr of long words to copy
        lea     dde_name(pc),a1
        lea     th_verid(a0),a2
        move.l  dde_vers(pc),(a2)+      ; version of thing
nam_cpy
        move.l  (a1)+,(a2)+
        dbf     d0,nam_cpy      ; copy name of thing

        move.l  a2,th_thing(a0) ; address of start of thing (INFO extension)
        lea     thg_head(pc),a1
        suba.l  a2,a1           ; offset to next thing
        move.l  #thh.flag,(a2)+ ; thing header 'THG%'
        move.l  #$01000003,(a2)+; extension with sub-thing
        move.l  a1,(a2)+        ; offset to next thing
        move.l  #'INFO',(a2)+   ; extra id
        clr.l   (a2)+           ; no param def
        clr.l   (a2)+           ;          descr
        move.w  rts(pc),(a2)+   ; thing code, here follows the data from $1a onwards
        move.l  d7,(a2)+        ; first the job id, then list of files, then def buffer for jobs (array)

        move.l  a0,a1           ;address of thing linkage
        moveq   #sms.lthg,d0    ;Link in new Thing
        jsr     (a4)            ;(th_entry)

; nu moeten we nog even zorgen dat onze job ook de thing gebruikt
        move.l  #'INFO',d2      ;extra id
        moveq   #sms.uthg,d0    ;use thing
        moveq   #-1,d3          ;timeout
        move.l  d7,d1           ;job id
        lea     dde_name(pc),a0 ;thing name
        jsr     (a4)            ;(th_entry)
        bne.s   kill

; DATAdesign mutex thing initialiseren
        xref    mutexini
        jsr     mutexini

        lea     linkmess(pc),a1 ; message
        sub.l   a0,a0           ; to channel 0
        move.w  ut.wtext,a2
        jsr     (a2)

ok      moveq   #0,d0           ; prepare for Basic
kill
rts     rts                     ; and return

; nu komt de thing header
; daarvoor definieren we eerst enkele macro's
label   setnum  0
exte    macro   naam
ext[label]
        dc.l    thh.flag        ; flag signalling standard header
        dc.l    $01000003       ; type of thing
lablp   setstr  ext[label]
label   setnum  [label]+1
        dc.l    ext[label]-[lablp]      ; offset to next thing in list
        dc.l    '[naam]'        ; extra ID
        dc.l    0               ; offset to parameter description
        dc.l    0               ; offset to description
        xref    cod_[naam]
        bra     cod_[naam]
        endm

last     macro   naam
ext[label]
        dc.l    thh.flag        ; flag signalling standard header
        dc.l    $00000003       ; type of thing
        dc.l    0               ; this is the last one
        dc.l    '[naam]'        ; extra ID
        dc.l    0               ; offset to parameter description
        dc.l    0               ; offset to description
        xref    cod_[naam]
        bra     cod_[naam]
        endm


        section text
thg_head
        exte    ADDF    ; ADD Field
        exte    BACK    ; BACKup of file
        exte    BCKW    ; BaCKWard some records (= fast x times PREV)
        exte    CMRK    ; Clear all MaRK statusses
        exte    CNTA    ; CouNT All records
        exte    CNTF    ; CouNT all Fields
        exte    CNTR    ; CouNT visible Records
        exte    CYCB    ; CYCle through Buffers for this job
        exte    CYCF    ; CYCle through Fields
        exte    CYCL    ; CYCLe through files being edited/viewed
        exte    DATE    ; get DATE when record was last implemented
        exte    DEFB    ; DEFault Buffer setting
        exte    DEFF    ; DEFault Field setting
        exte    DEFI    ; DEFault Index setting
        exte    DELE    ; DELEte current record from file
        exte    DUPL    ; DUPLicate record
        exte    FDEV    ; FileDEVice we are working on
        exte    FILT    ; set FILTer parameters
        exte    FLDC    ; FieLD Clear (buffer or all)
        exte    FLDD    ; FieLD Delete
        exte    FLDN    ; FieLDName when id given
        exte    FLDR    ; FieLD Rename
        exte    FLDT    ; FieLDType when id given
        exte    FNAM    ; FileNAMe we are working on
        exte    FNDD    ; FiND Double
        exte    FNDI    ; FiND Integer
        exte    FNDS    ; FiND String
        exte    FORW    ; FORWard some records (fast x times NEXT)
        exte    FRST    ; go to FiRST editable record
        exte    GARB    ; GARBage collection
        exte    GCHR    ; Get CHaR in a character array (string)
        exte    GDBL    ; Get DouBLe (fp8) array element
        exte    GFLD    ; Get FieLD contents
        exte    GFST    ; Get FileSTatus (memory or disk-based)
        exte    GIFL    ; Get Index Filter Level parameters
        exte    GIRS    ; Get Inter Record Space
        exte    GISL    ; Get Index Sort Level parameters
        exte    GLNG    ; Get LoNG integer array element
        exte    GMRK    ; Get MaRK status
        exte    GREC    ; Get RECord with given id and put it in buffer
        exte    GSHR    ; Get SHoRt integer array element
        exte    GSTR    ; Get STRing as a line
        exte    GVST    ; Get View STatus
        exte    IDBF    ; ID of default BuFfer
        exte    IDEL    ; Index DELete
        exte    IDFI    ; ID of FIeld with given name
        exte    IDIN    ; ID of default INdex
        exte    IDRE    ; ID of REcord we are editing
        exte    IFND    ; Index FiND
        exte    IIMP    ; Index IMPlement
        exte    ILOA    ; Index LOAd
        exte    IMPL    ; IMPLement record in file
        exte    INSE    ; INSert array Elements
        exte    IRMV    ; Index ReMoVe
        exte    ISAV    ; Index SAVe
        exte    IUPD    ; Index UPDate
        exte    LAST    ; go to LAST editable record
        exte    LENF    ; get LENgth of a field
        exte    LENR    ; get LENgth of the current record
        exte    LENS    ; get LENgth of a String as a line
        exte    NEWF    ; NEW File creation
        exte    NEWR    ; NEW Record start
        exte    NEXT    ; go to NEXT editable record
        exte    NRLN    ; get NumbeR of LiNes in a text field
        exte    PREV    ; go to PREVious editable record
        exte    RMVE    ; ReMoVe array Elements
        exte    SAVE    ; SAVE file to medium
        exte    SAVI    ; SAVe record sequence Initialise
        exte    SAVF    ; SAVe record sequence Finish
        exte    SAVR    ; SAVe record
        exte    SCHR    ; Set CHaR in a character array (string)
        exte    SDBL    ; Set DouBLe (fp8) array element
        exte    SFLD    ; Set FieLD contents
        exte    SFST    ; Set FileSTatus (memory or disk-based)
        exte    SIFL    ; Set Index Filter Level parameters
        exte    SIRS    ; Set Inter Record Space
        exte    SISL    ; Set Index Sort Level parameters
        exte    SLNG    ; Set LoNG integer array element
        exte    SMRK    ; Set MaRK status
        exte    SORT    ; set SORT parameters
        exte    SSHR    ; Set SHoRt integer array element
        exte    SSTR    ; Set STRing as a line
        exte    SVST    ; Set View STatus
        exte    UNUS    ; UNUSe a buffer
        last    {USE }  ; USE a file
;
        end
